//\/////
//\  coolTip Anchor Plugin
//\  This file requires coolTip 2.0 or later.
//\  Modified August 21, 2006, April 5, 2012, February 25, 2013
//\
//\  You may not remove or change this notice.
//\  Copyright Robert E Boughner 2005. All rights reserved.
//\  
//\  This plugin is governed by the same restrictions set forth
//\  in the prologue to cCore.js.
//\/////
if(!cInfo.meets(2.0))alert('coolTip 2.0 or later is required for the Anchor Plugin.');else{cLoaded=0;registerCommands('anchor,anchorx,anchory,noanchorwarn,anchoralign');setDefaultVariables('anchor||anchorx|0|anchory|0|noanchorwarn|1|anchoralign|UL');function setAnchorVariables(obj){obj.anchor=cd_anchor;obj.anchorx=cd_anchorx;obj.anchory=cd_anchory;obj.noanchorwarn=cd_noanchorwarn;obj.anchoralign=cd_anchoralign;obj.rmrkObj=null;obj.rmrkPosition=[];}
function parseAnchorExtras(cObj,i,ar){var v,kN,po,k=i,cD=true;if(cObj!=null){cD=false;po=cObj.pop;}
if(k<ar.length){if(ar[k]==ANCHOR){v=escSglQuote(ar[(++k)]);(cD?cd_anchor=v:po.anchor=v);return k;}
if(ar[k]==ANCHORX){v=ar[(++k)];(cD?cd_anchorx=v:po.anchorx=v);return k;}
if(ar[k]==ANCHORY){v=ar[(++k)];(cD?cd_anchory=v:po.anchory=v);return k;}
if(ar[k]==NOANCHORWARN){(cD?cd_noanchorwarn=toggle(cd_noanchorwarn,1):po.noanchorwarn=toggle(po.noanchorwarn,1));return k;}
if(ar[k]==ANCHORALIGN){kN=opt_MULTIPLEARGS(++k,ar);v=kN[1];(cD?cd_anchoralign=v:po.anchoralign=v);return kN[0];}}
return-1;}
function checkAnchorObject(lyr){lyr=(lyr)?lyr:cTip;var po=lyr.pop;if(!po)return false;if(po.anchor){po.rmrkObj=getAnchorObjRef(po.anchor);if(!po.rmrkObj){if(po.noanchorwarn){alert('WARNING!  Reference mark "'+po.anchor+'" not found.');return false;}else po.anchor='';}}
return true;}
function anchorHorizontal(lyr,browserWidth,horizontalScrollAmount,widthFix){if(lyr){var po=lyr.pop;if(po.anchor==""||typeof po.rmrkPosition[0]===cUdf)return void(0);if(typeof po.followscroll !==cUdf&&po.followscroll&&po.sticky)po.relx=po.rmrkPosition[0];return po.rmrkPosition[0];}}
function anchorVertical(lyr,browserHeight,verticalScrollAmount){if(lyr){var po=lyr.pop;if(po.anchor==""||typeof po.rmrkPosition[1]===cUdf)return void(0);if(typeof po.followscroll !==cUdf&&po.followscroll&&po.sticky)po.rely=po.rmrkPosition[1];return po.rmrkPosition[1];}}
function anchorPreface(obj){if(!obj)throw new Error("No layer object specified in call to anchorPreface.");else{var po=obj.pop;if(isNull(po.rmrkObj))return;po.rmrkPosition=getAnchorLocation(obj,po.rmrkObj);}}
function getAnchorObjRef(aObj){return getRefById(aObj,cFrame.document)||getRefByName(aObj,cFrame.document);}
function getAnchorLocation(obj,objRef){if(!obj)throw new Error("No layer object specified in call to getAnchorLocation.");var of,position,offsets,po=obj.pop;position=getPosition(objRef);offsets=[po.anchorx,po.anchory];offsets[0]+=position.x;offsets[1]+=position.y;of=getAnchorOffsets(obj,objRef);if(typeof po.dragimg !==cUdf&&po.dragimg){return offsets;}
offsets[0]+=of[0];offsets[1]+=of[1];return offsets;}
function getAnchorOffsets(obj,mkObj){if(!obj)throw new Error("No layer object specified in call to getAnchorOffsets.");var fx=fy=0,mp,puc,mkAry,po=obj.pop;var mW=mH=pW=pH=0;var off=[0,0];mkAry=po.anchoralign.split(',');if(mkAry.length<3){mp=mkAry[0].toUpperCase();puc=(mkAry.length==1)?mp:mkAry[1].toUpperCase();}else if(mkAry.length==3){if(!isNaN(mkAry[0])){mp=mkAry.slice(0,2);puc=mkAry[2].toUpperCase();}else{mp=mkAry[0].toUpperCase();puc=mkAry.slice(1);}
}else{mp=mkAry.slice(0,2);puc=mkAry.slice(2);}
pW=obj.offsetWidth;pH=obj.offsetHeight;if(mkObj.toString().indexOf('Anchor')!=-1){mp='UL';}else{mW=mkObj.offsetWidth;mH=mkObj.offsetHeight;}
if(!isNaN(mp)||isType(mp,'object')){if(isType(mp,'object')){fx=parseFloat(mp[0]);fy=parseFloat(mp[1]);}else fx=fy=parseFloat(mp);off=[Math.round(fx*mW),Math.round(fy*mH)];}else{if(mp=='UR')off=[mW,0];else if(mp=='LL')off=[0,mH];else if(mp=='LR')off=[mW,mH];}
if(typeof po.dragimg!==cUdf&&po.dragimg)return off;else{if(!isNaN(puc)||isType(puc,'object') ){if(isType(puc,'object')){fx=parseFloat(puc[0]);fy=parseFloat(puc[1]);}else fx=fy=parseFloat(puc);off[0]-=Math.round(fx*pW);off[1]-=Math.round(fy*pH);}else{if(puc=='UR'){off[0]-=pW;}
else if(puc=='LL'){off[1]-=pH;}
else if(puc=='LR'){off[0]-=pW;off[1]-=pH;}}
return off;}}
function getPosition(obj){let rect,X=0,Y=0;if(obj){rect=obj.getBoundingClientRect();X=rect.left+(window.scrollX||window.pageXOffset);Y=rect.top+(window.scrollY||window.pageYOffset);}
return {x: X,y: Y}}
function getRefById(l,d){var r="",j;d=(d||document);return(d.getElementById)?d.getElementById(l):d.all[l];}
function getRefByName(l,d){var r=null;d=(d||document);if(d.images[l])r=d.images[l];else if(d.anchors[l])r=d.anchors[l];return r;}
registerRunTimeFunction(setAnchorVariables);registerCmdLineFunction(parseAnchorExtras);registerPostParseFunction(checkAnchorObject);registerHook("ctCreatePopup",anchorPreface,FAFTER);registerHook("horizontalPlacement",anchorHorizontal,FCHAIN);registerHook("verticalPlacement",anchorVertical,FCHAIN);if(cInfo.meets(1.00))registerNoParameterCommands('noanchorwarn');cLoaded=1;}
